/*
 * Copyright (C) 2019 Intel Corporation
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 */
package org.securedroneid.android.app;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.Transformations;
import androidx.lifecycle.ViewModel;

import org.securedroneid.android.data.AircraftObject;
import org.securedroneid.android.data.AuthenticationData;
import org.securedroneid.android.data.Connection;
import org.securedroneid.android.data.DNSData;
import org.securedroneid.android.data.Identification;
import org.securedroneid.android.data.Link;
import org.securedroneid.android.data.LocationData;
import org.securedroneid.android.data.Manifest;
import org.securedroneid.android.data.OperatorIdData;
import org.securedroneid.android.data.SelfIdData;
import org.securedroneid.android.data.SystemData;
import org.securedroneid.android.data.Wrapper;

public class DetailViewModel extends ViewModel {
    private final MutableLiveData<AircraftObject> selected = new MutableLiveData<>();

    void select(AircraftObject item) {
        selected.setValue(item);
    }

    final LiveData<Identification> identification1 = Transformations.switchMap(selected,
            input -> input.identification1);

    final LiveData<Identification> identification2 = Transformations.switchMap(selected,
            input -> input.identification2);

    final LiveData<Connection> connection = Transformations.switchMap(selected,
            input -> input.connection);

    public final LiveData<LocationData> location = Transformations.switchMap(selected,
            input -> input.location);

    public final LiveData<DNSData> dns = Transformations.switchMap(selected,
            input -> input.dns);

    public final LiveData<Manifest> manifest = Transformations.switchMap(selected,
            input -> input.manifest);
    public final LiveData<Wrapper> wrapper = Transformations.switchMap(selected,
            input -> input.wrapper);

    public final LiveData<Link> link = Transformations.switchMap(selected,
            input -> input.link);

    final LiveData<AuthenticationData> authentication = Transformations.switchMap(selected,
            input -> input.authentication);

    final LiveData<SelfIdData> selfid = Transformations.switchMap(selected,
            input -> input.selfid);

    public final LiveData<SystemData> system = Transformations.switchMap(selected,
            input -> input.system);

    final LiveData<OperatorIdData> operatorid = Transformations.switchMap(selected,
            input -> input.operatorid);
}
